#include "systemc.h"
#include "bus_if.h"

class bus_ch
: public bus_if,
  public sc_channel
{
 public:
  bus_ch(sc_module_name nm, unsigned mem_size,
	 sc_time cycle_time): sc_channel(nm),
    _cycle_time(cycle_time)
    {
      _mem = new char[mem_size];
      memse(_mem, 0, mem_size);
    }

  ~bus_ch{ delete [] _mem; }

  virtual burst_read(char *data, int addr, int len)
    {
      _bus_mutex.lock();
      wait(len * _cycle_time);
      memcpy(data, _mem+addr, len);
      _bus_mutex.unlock();
    }
  virtual burst_write(char *data, int addr, int len)
    {
      _bus_mutex.lock();
      wait(len * _cycle_time);
      memcpy(_mem+addr, data, len);
      _bus_mutex.unlock();
    }


 protected:
  char *_mem;
  sc_time _cycle_time;
  sc_mutex _bus_mutex;
};
